> ## Documentation Index
> Fetch the complete documentation index at: https://docs.dfns.co/llms.txt
> Use this file to discover all available pages before exploring further.

# Submit Onchain Sign Output

#### Authentication

✅ Organization User (`CustomerEmployee`)\
❌ Delegated User (`EndUser`)\
✅ Service Account

#### Required Permissions

`KeyStores:OnchainSignatures:Create`: Always required.


## OpenAPI

````yaml /openapi.yaml post /key-stores/{storeId}/onchain-sign/output
openapi: 3.1.0
info:
  version: 1.891.1
  title: Dfns
servers:
  - url: https://api.dfns.io
    description: Default - Europe
  - url: https://api.uae.dfns.io
    description: UAE
  - url: https://api.dfns.ninja
    description: <Deprecated> Staging
security: []
paths:
  /key-stores/{storeId}/onchain-sign/output:
    post:
      tags:
        - Signers
      summary: Submit Onchain Sign Output
      parameters:
        - schema:
            type: string
            minLength: 1
          required: true
          name: storeId
          in: path
      requestBody:
        required: true
        content:
          multipart/form-data:
            schema:
              type: object
              properties:
                data:
                  type: object
                  properties:
                    fileChecksum:
                      type: string
                      pattern: ^[a-f0-9]{64}$
                    outputJson:
                      type: object
                      properties:
                        type:
                          type: string
                          enum:
                            - keystore-output
                        version:
                          type: number
                          enum:
                            - 1
                        org_id:
                          type: string
                          minLength: 1
                        fleet_id:
                          type: string
                          minLength: 1
                        keystore_id:
                          type: string
                          minLength: 1
                        group_id:
                          type: string
                          minLength: 1
                        status:
                          type: string
                          enum:
                            - success
                            - partial
                            - fail
                        outputs:
                          type: object
                          additionalProperties:
                            oneOf:
                              - type: object
                                properties:
                                  type:
                                    type: string
                                    enum:
                                      - proof-of-control-v1
                                  result:
                                    anyOf:
                                      - type: object
                                        properties:
                                          success:
                                            type: object
                                            properties:
                                              signer_public_key:
                                                type: string
                                                pattern: ^[a-f0-9]+$
                                              prefix:
                                                type: string
                                                pattern: ^[a-f0-9]+$
                                              message:
                                                type: string
                                                minLength: 1
                                              exact_bytes_signed:
                                                type: string
                                                pattern: ^[a-f0-9]{64}$
                                              signature:
                                                type: string
                                                pattern: ^[a-f0-9]+$
                                            required:
                                              - signer_public_key
                                              - prefix
                                              - message
                                              - exact_bytes_signed
                                              - signature
                                        required:
                                          - success
                                        additionalProperties: false
                                      - type: object
                                        properties:
                                          fail:
                                            type: object
                                            properties:
                                              message:
                                                type: string
                                                minLength: 1
                                              code:
                                                type: string
                                                minLength: 1
                                            required:
                                              - message
                                              - code
                                        required:
                                          - fail
                                        additionalProperties: false
                                required:
                                  - type
                                  - result
                                title: Proof of Control Output
                              - type: object
                                properties:
                                  type:
                                    type: string
                                    enum:
                                      - onchain-sign-v1
                                  result:
                                    anyOf:
                                      - type: object
                                        properties:
                                          success:
                                            type: object
                                            additionalProperties:
                                              type: object
                                              properties:
                                                signer_public_key:
                                                  type: string
                                                  pattern: ^[a-f0-9]+$
                                                exact_bytes_signed:
                                                  type: string
                                                  pattern: ^[a-f0-9]+$
                                                signature:
                                                  type: string
                                                  pattern: ^[a-f0-9]+$
                                              required:
                                                - signer_public_key
                                                - exact_bytes_signed
                                                - signature
                                        required:
                                          - success
                                        additionalProperties: false
                                      - type: object
                                        properties:
                                          fail:
                                            type: object
                                            properties:
                                              message:
                                                type: string
                                                minLength: 1
                                              code:
                                                type: string
                                                minLength: 1
                                            required:
                                              - message
                                              - code
                                        required:
                                          - fail
                                        additionalProperties: false
                                required:
                                  - type
                                  - result
                                title: Onchain Sign Output
                      required:
                        - type
                        - version
                        - org_id
                        - fleet_id
                        - keystore_id
                        - group_id
                        - status
                        - outputs
                  required:
                    - fileChecksum
                    - outputJson
                file:
                  type: string
                  format: binary
              required:
                - data
                - file
      responses:
        '200':
          description: Success
          content:
            application/json:
              schema:
                type: object
                properties:
                  status:
                    type: string
                    enum:
                      - success
                      - partial
                required:
                  - status
      security:
        - authenticationToken: []
          userActionSignature: []
components:
  securitySchemes:
    authenticationToken:
      type: http
      scheme: bearer
      bearerFormat: JWT
      description: >-
        **Bearer Token:** Used to authenticate API requests.

        More details how to generate the token: [Authentication
        flows](https://docs.dfns.co/api-reference/auth/login-flows)
    userActionSignature:
      type: apiKey
      in: header
      name: X-DFNS-USERACTION
      description: >-
        **User Action Signature:** Used to sign the change-inducing API
        requests.

        More details how to generate the token: [User Action Signing
        flows](https://docs.dfns.co/api-reference/auth/signing-flows)

````